/*
Developer Formater
http://wordpress.org/extend/plugins/devformatter/
Developer Formatter system to WordPress. Powered by <a href="http://qbnz.com/highlighter/">GeSHi</a> server-side highlight system.
Version: 2008.0.1.1
Author: Gilberto Saraiva
Author URI: http://gsaraiva.projects.pro.br/

Copyright (c) 2008 Gilberto Saraiva
Released under the GNU General Public License (GPL)
http://www.gnu.org/licenses/gpl.txt
*/

devfmt_Def_switchEditors = (typeof switchEditors != 'undefined') ? switchEditors : false;
switchEditors = {
    saveCallback : (devfmt_Def_switchEditors)? devfmt_Def_switchEditors.saveCallback: null,
    go : (devfmt_Def_switchEditors)? devfmt_Def_switchEditors.go : null,
    edToggle : (devfmt_Def_switchEditors)? devfmt_Def_switchEditors.edToggle : null,
    wpSetDefaultEditor : (devfmt_Def_switchEditors)? devfmt_Def_switchEditors.wpSetDefaultEditor : null,

    pre_wpautop : function(content){
        // save double space
        entities = '160,nbsp, ,38,amp,&,34,quot,",162,cent,,8364,euro,,163,pound,,165,yen,,169,copy,,174,reg,,8482,trade,,8240,permil,,60,lt,<,62,gt,>,8804,le,=,8805,ge,=,176,deg,,8722,minus,-'.split(',');
        for(i = 0; i < entities.length - 1; i+=3)
          content = content.replace(new RegExp('&'+entities[i+1]+';', 'g'), '{{devfmt('+i+')}}');

        // save pre|code|samp|script tags lines
        content = content.replace(/<(pre|code|samp|script)[^>]*>[\s\S]+?<\/\1>/g, function(a) {
            a = a.replace(/<br ?\/?>[\r\n]*/g, '{{wp_newline}}');
            return a.replace(/<\/?p( [^>]*)?>[\r\n]*/g, '{{wp_newline}}');
        });

        // Pretty it up for the source editor
        var blocklist1 = 'blockquote|ul|ol|li|table|thead|tbody|tr|th|td|div|h[1-6]|p';
        content = content.replace(new RegExp('\\s*</('+blocklist1+')>\\s*', 'mg'), '</$1>\n');
        content = content.replace(new RegExp('\\s*<(('+blocklist1+')[^>]*)>', 'mg'), '\n<$1>');

        // Mark </p> if it has any attributes.
        content = content.replace(new RegExp('(<p [^>]+>.*?)</p>', 'mg'), '$1</p#>');

        // Sepatate <div> containing <p>
        content = content.replace(new RegExp('<div([^>]*)>\\s*<p>', 'mgi'), '<div$1>\n\n');

        // Remove <p> and <br />
        content = content.replace(new RegExp('\\s*<p>', 'mgi'), '');
        content = content.replace(new RegExp('\\s*</p>\\s*', 'mgi'), '\n\n');
        content = content.replace(new RegExp('\\n\\s\\n', 'mgi'), '\n\n');
        content = content.replace(new RegExp('\\s*<br ?/?>\\s*', 'gi'), '\n');

        // Fix some block element newline issues
        content = content.replace(new RegExp('\\s*<div', 'mg'), '\n<div');
        content = content.replace(new RegExp('</div>\\s*', 'mg'), '</div>\n');
        content = content.replace(new RegExp('\\s*\\[caption([^\\[]+)\\[/caption\\]\\s*', 'gi'), '\n\n[caption$1[/caption]\n\n');
        content = content.replace(new RegExp('caption\\]\\n\\n+\\[caption', 'g'), 'caption]\n\n[caption');

        var blocklist2 = 'blockquote|ul|ol|li|table|thead|tr|th|td|h[1-6]|pre';
        content = content.replace(new RegExp('\\s*<(('+blocklist2+') ?[^>]*)\\s*>', 'mg'), '\n<$1>');
        content = content.replace(new RegExp('\\s*</('+blocklist2+')>\\s*', 'mg'), '</$1>\n');
        content = content.replace(new RegExp('<li([^>]*)>', 'g'), '\t<li$1>');

        if ( content.indexOf('<object') != -1 ) {
            content = content.replace(new RegExp('\\s*<param([^>]*)>\\s*', 'mg'), "<param$1>");
            content = content.replace(new RegExp('\\s*</embed>\\s*', 'mg'), '</embed>');
        }

        // Unmark special paragraph closing tags
        content = content.replace(new RegExp('</p#>', 'g'), '</p>\n');
        content = content.replace(new RegExp('\\s*(<p [^>]+>.*</p>)', 'mg'), '\n$1');

        // Trim whitespace
        content = content.replace(new RegExp('^\\s*', ''), '');
        content = content.replace(new RegExp('[\\s\\u00a0]*$', ''), '');

        // put back the line breaks in pre|script
        content = content.replace(/{{wp_newline}}/g, '\n');
        content = content.replace(/{{devfmt\(([0-9]+)\)}}/g, function(a){
          code = a.substr(9,a.length); code = parseInt(code.substr(0, code.indexOf(')')));
          return a.replace(/{{devfmt\(([0-9]+)\)}}/g, entities[code+2]);
        });

        // Hope.
        return content;
    },

    wpautop : function(pee) {
        var blocklist = 'table|thead|tfoot|caption|colgroup|tbody|tr|td|th|div|dl|dd|dt|ul|ol|li|pre|select|form|blockquote|address|math|p|h[1-6]';

        pee = pee + "\n\n";
        pee = pee.replace(new RegExp("  ", 'g'), "{{wp_doublespace}}");

        pee = pee.replace(new RegExp('<br />\\s*<br />', 'gi'), "\n\n");
        pee = pee.replace(new RegExp('(<(?:'+blocklist+')[^>]*>)', 'gi'), "\n$1");
        pee = pee.replace(new RegExp('(</(?:'+blocklist+')>)', 'gi'), "$1\n\n");
        pee = pee.replace(new RegExp("\\r\\n|\\r", 'g'), "\n");
        pee = pee.replace(new RegExp("\\n\\s*\\n+", 'g'), "\n\n");
        pee = pee.replace(new RegExp('([\\s\\S]+?)\\n\\n', 'mg'), "<p>$1</p>\n");
        //pee = pee.replace(new RegExp('<p>\\s*?</p>', 'gi'), '');
        pee = pee.replace(new RegExp('<p>\\s*(</?(?:'+blocklist+')[^>]*>)\\s*</p>', 'gi'), "$1");
        pee = pee.replace(new RegExp("<p>(<li.+?)</p>", 'gi'), "$1");
        pee = pee.replace(new RegExp('<p>\\s*<blockquote([^>]*)>', 'gi'), "<blockquote$1><p>");
        pee = pee.replace(new RegExp('</blockquote>\\s*</p>', 'gi'), '</p></blockquote>');
        pee = pee.replace(new RegExp('<p>\\s*(</?(?:'+blocklist+')[^>]*>)', 'gi'), "$1");
        pee = pee.replace(new RegExp('(</?(?:'+blocklist+')[^>]*>)\\s*</p>', 'gi'), "$1");
        pee = pee.replace(new RegExp('\\n', 'gi'), "<br />\n");
        pee = pee.replace(new RegExp('(</?(?:'+blocklist+')[^>]*>)\\s*<br />', 'gi'), "$1");
        pee = pee.replace(new RegExp('<br />(\\s*</?(?:p|li|div|dl|dd|dt|th|pre|code|samp|td|ul|ol)>)', 'gi'), '$1');
        pee = pee.replace(new RegExp('(?:<p>|<br ?/?>)*\\s*\\[caption([^\\[]+)\\[/caption\\]\\s*(?:</p>|<br ?/?>)*', 'gi'), '[caption$1[/caption]');

        // Fix the pre|code|samp|script tags
        pee = pee.replace(/<(pre|code|samp|script)[^>]*>[\s\S]+?<\/\1>/g, function(a) {
          a = a.replace(/<br ?\/?>[\r\n]*/g, '\n');
          return a.replace(/<\/?p( [^>]*)?>[\r\n]*/g, '\n');
        });
        pee = pee.replace(/<(code|samp)[^>]*>[\s\S]+?<\/\1>/g, function(a){
          return a.replace(new RegExp('\\n', 'gi'), "<br />");
        });
        pee = pee.replace(/{{wp_doublespace}}/g, '&nbsp;&nbsp;');
	    return pee;
    }
}