<?php
/*
Plugin Name: Developer Formater
Plugin URI: http://wordpress.org/extend/plugins/devformatter/
Description: Developer Formatter system to WordPress. Powered by <a href="http://qbnz.com/highlighter/">GeSHi</a> server-side highlight system.
Version: 2008.0.1.2
Author: Gilberto Saraiva
Author URI: http://gsaraiva.projects.pro.br/

Copyright (c) 2008 Gilberto Saraiva
Released under the GNU General Public License (GPL)
http://www.gnu.org/licenses/gpl.txt
*/

  $version = "2008.0.1.2";
  define('DEVFMT_FOLDER', dirname(plugin_basename(__FILE__)), TRUE);
  define('DEVFMT_PATH', dirname(__FILE__), TRUE);
  define('DEVFMT_URL', get_option('siteurl')."/wp-content/plugins/devformatter/");
  define('DEVFMT_GESHIPATH', DEVFMT_PATH.DIRECTORY_SEPARATOR."geshi".DIRECTORY_SEPARATOR."geshi");
  require_once(DEVFMT_PATH.DIRECTORY_SEPARATOR.'geshi'.DIRECTORY_SEPARATOR.'geshi.php');

  $DevFmt_FiltersToAvoid = Array("wptexturize", "wpautop", "force_balance_tags");

  $DevFmt_Config = Array();
  $DevFmt_SuppLangs = Array();

  function devfmt_ReadConfig(){
    GLOBAL $DevFmt_Config, $DevFmt_SuppLangs, $table_prefix, $wpdb;
    $DevFmt_Config = $wpdb->get_row("SELECT * FROM `{$table_prefix}devfmt_config`", ARRAY_A);
  }

  function devfmt_UpdateConfig(){
    GLOBAL $DevFmt_Config, $table_prefix, $wpdb;

    $wpdb->get_row("DELETE from `{$table_prefix}devfmt_config`");
    $wpdb->query("insert into `{$table_prefix}devfmt_config` (`".
      implode("`,`", array_keys($DevFmt_Config))."`) ".
      "values ('".implode("','",array_values($DevFmt_Config))."');");
    devfmt_ReadConfig();
  }

  function devfmt_ReadSupportedLangs(){
    GLOBAL $DevFmt_Config, $DevFmt_SuppLangs, $table_prefix, $wpdb;
    $DevFmt_SuppLangs = $wpdb->get_results("SELECT * FROM `{$table_prefix}devfmt_supplangs`", ARRAY_A);
  }

  function devfmt_UpdateSupportedLangs(){
    GLOBAL $DevFmt_Config, $DevFmt_SuppLangs, $table_prefix, $wpdb;

    $NewSuppLangs = Array();
    if($dh = opendir($DevFmt_Config['geshilangpath']))
      while(($file = readdir($dh)) !== false)
        if(($file != '.') && ($file != '..'))
          if(!is_dir($file) && (strtolower(array_pop(explode(".", $file))) == "php")){
            include($DevFmt_Config['geshilangpath']."/".$file);
            if(isset($language_data)){
              $NewSuppLangs[] = Array($language_data['LANG_NAME'], $file);
              unset($language_data);
            }
          }
    $wpdb->query("DELETE from `{$table_prefix}devfmt_supplangs`");
    foreach($NewSuppLangs as $lang){
      $wpdb->query("insert into `{$table_prefix}devfmt_supplangs` (`langname`,`langfile`,`fav`) ".
        "values ('".$lang[0]."','".$lang[1]."','0');");
    }
    devfmt_ReadSupportedLangs();
  }

  function devfmt_ReadConfigAndLangs(){
    devfmt_ReadConfig();
    devfmt_ReadSupportedLangs();
  }

  function devfmt_addPage(){
    GLOBAL $DevFmt_Config, $DevFmt_SuppLangs, $table_prefix, $wpdb;

    devfmt_ReadConfigAndLangs();

    if(isSet($_POST)){
      if(IsSet($_POST['UpdateConfig'])){
        $updatefiles = (strtolower($DevFmt_Config['geshilangpath']) != strtolower($_POST['geshilangpath']));
        $DevFmt_Config['geshilangpath'] = $_POST['geshilangpath'];
        $DevFmt_Config['geshiuselink'] = (IsSet($_POST['geshiuselink'])? "1": "0");
        $DevFmt_Config['displaylinenumbers'] = (IsSet($_POST['displaylinenumbers'])? "1": "0");
        $DevFmt_Config['usedevformat'] = (IsSet($_POST['usedevformat'])? "1": "0");
        $DevFmt_Config['devfmtcss'] = $_POST['devfmtcss'];
        $DevFmt_Config['linkjquery'] = (IsSet($_POST['linkjquery'])? "1": "0");
        $DevFmt_Config['highlighttags'] = (IsSet($_POST['highlighttags'])? "1": "0");
        $DevFmt_Config['copyclipboartext'] = $_POST['copyclipboartext'];

        devfmt_UpdateConfig();

        if($updatefiles)
          devfmt_UpdateSupportedLangs();
      }

      if(IsSet($_POST['UpdateLangs'])){
        devfmt_UpdateSupportedLangs();
      }
    }

    if($DevFmt_Config['geshilangpath'] == "")
      $DevFmt_Config['geshilangpath'] = DEVFMT_GESHIPATH;
?>
	<div class="wrap">
		<h2>DevFormatter</h2>
    <h3>Configurations</h3>
    <form method="post" action="options-general.php?page=devformatter/devformatter.php">
    <fieldset class="options">
    <table class="form-table">
    <tbody>
    <tr valign="top">
    <th scope="row"><label for="geshilangpath">GeSHI Languages Path</label></th>
    <td><input name="geshilangpath" type="text" value="<?php echo $DevFmt_Config['geshilangpath']; ?>" size="80" />
    <br />
    Your default path = <?php echo DEVFMT_GESHIPATH ?>
    </td>
    </tr>
    <tr valign="top">
    <th scope="row"><label for="geshiuselink">Display Links on reserved words</label></th>
    <td><input name="geshiuselink" type="checkbox"<?php echo (($DevFmt_Config['geshiuselink'])? " checked": ""); ?>/>
    </td>
    </tr>
    <tr valign="top">
    <th scope="row"><label for="displaylinenumbers">Display Line Numbers</label></th>
    <td><input name="displaylinenumbers" type="checkbox"<?php echo (($DevFmt_Config['displaylinenumbers'])? " checked": ""); ?>/>
    </td>
    </tr>
    <tr valign="top">
    <th scope="row"><label for="copyclipboartext">Copy to Clipboard Text</label></th>
    <td><input name="copyclipboartext" type="text" value="<?php echo $DevFmt_Config['copyclipboartext']; ?>" size="80" />
    </td>
    </tr>
    <tr valign="top">
    <th scope="row"><label for="devfmtcss">DevFormatter CSS</label></th>
    <td><textarea name="devfmtcss" rows="6" cols="60"><?php echo $DevFmt_Config['devfmtcss']; ?></textarea></td>
    </tr>
    <tr valign="top">
    <th scope="row"><label for="linkjquery">Link jQuery</label></th>
    <td><input name="linkjquery" type="checkbox"<?php echo (($DevFmt_Config['linkjquery'])? " checked": ""); ?>/>
    <br />Disable this option if you already have jQuery linked on your page.
    </td>
    </tr>
    <tr valign="top">
    <th scope="row"><label for="highlighttags">Highlight Tags matchs on the content</label></th>
    <td><input name="highlighttags" type="checkbox"<?php echo (($DevFmt_Config['highlighttags'])? " checked": ""); ?>/>
    <br />If enabled, DevFormatter will make the word highlighted if it match with some of listed tags of the page.
    </td>
    </tr>
    <tr valign="top">
    <th scope="row"><label for="usedevformat">Use DevFormatter System</label></th>
    <td><input name="usedevformat" type="checkbox"<?php echo (($DevFmt_Config['usedevformat'])? " checked": ""); ?>/>
    <br />
    The DevFomatter format system will create a better output for everybody that publish some techniques contents.<br />
    The formatter avoid excessives new lines when the new line is not necessary.<br />
    <br />
    Checkout the diference:<br />
    <table width="100%"><tbody><tr>
    <td valign="top">
    <?php
      $ExampleCode = "<code lang=\"php\">
  function GimmeGimmeAText(){
    return \"Take here, a text.\";
  }
  echo GimmeGimmeAText();
</code>";
    ?>
    <h4>Source code:</h4>
    <pre style="background:#fff;padding:4px;border:1px solid #ccc"><?php echo htmlentities($ExampleCode); ?></pre>
    </td>
    <td valign="top">
    <h4>WordPress display:</h4>
    <div style="background:#fff;padding:4px;border:1px solid #ccc;" lang="PHP"><?php
      echo wpautop(wptexturize(devfmt_ContentCheckCode($ExampleCode)));
    ?></div>
    </td>
    <td valign="top">
    <h4>DevFormatter display:</h4>
    <div style="background:#fff;padding:4px;border:1px solid #ccc" lang="PHP"><?php
      echo devfmt_ContentFormat($ExampleCode, 'example');
    ?></div>
    <script>
      jQuery(function(){
        devfmt_createTools('devcode');
      });
    </script>
    </td>
    </tr></tbody></table>

    </td>
    </tr>
    </tbody>
    </table>
    </fieldset>
    <p class="submit"><input type="submit" name="UpdateConfig" value="Update"/></p>
    </form>
  </div>
<?php

?>
	<div class="wrap">
    <form method="post" action="options-general.php?page=devformatter/devformatter.php">
		<h3>Current Supported Languages</h3>
    <p class="submit"><input type="submit" name="UpdateLangs" value="Update languages"/>&nbsp;You have <?php echo Count($DevFmt_SuppLangs) ?> supported langauges</p>
    </form>
  <table class="widefat">
  	<thead>
  	<tr>
      <th width=\"25%\"><?php _e('Language'); ?></th>
      <th><?php _e('Lang. File'); ?></th>
      <th><?php _e('Favorite'); ?></th>
    </tr>
  	</thead>
  	<tbody>
<?php
    foreach($DevFmt_SuppLangs as $Lang){
        $class = ('alternate' != $class) ? 'alternate' : '';
        echo "
        <tr class='$class'>
        <td>".$Lang['langname']."</td>
        <td>".$DevFmt_Config['geshilangpath'].DIRECTORY_SEPARATOR.$Lang['langfile']."</td>
        <td>".(($Lang['fav'])? "<strong>True</strong>" : "")."</td>
        </tr>";
    }
?>
    </tbody>
    </table>
    <br /><br />
    <em>Credits for GeSHi: <a href="http://qbnz.com/highlighter/">http://qbnz.com/highlighter/</a></em>
  </div>
<?php
  }

  function devfmt_addPages(){
  	add_options_page('DevFormatter', 'DevFormatter', 2, __FILE__, 'devfmt_addPage');
  }

  function devfmt_addInterface(){
    GLOBAL $DevFmt_Config, $DevFmt_SuppLangs, $table_prefix, $wpdb;

    devfmt_ReadConfigAndLangs();

    if(!current_user_can('edit_posts') && !current_user_can('edit_pages'))
      return;

    if(function_exists('load_plugin_textdomain'))
      load_plugin_textdomain('devformatter','/wp-content/plugins/devformatter/langs');
    add_filter("mce_external_plugins", "devfmt_addMCEPlugin", 0);
    add_filter("mce_buttons_2", "devfmt_addMCEButton", 0);

    add_action('edit_page_form', 'devfmt_addHTMLButton');
    add_action('edit_form_advanced', 'devfmt_addHTMLButton');
  }

  function devfmt_addMCEButton($AButtons){
    $charmapIndex = array_search('charmap', $AButtons);
    $res = array();
    for($i = 0; $i < Count($AButtons); $i++){
      $res[] = $AButtons[$i];
      if($i == $charmapIndex)
        $res[] = "devformatter";
    }

    return $res;
  }

  function devfmt_addMCEPlugin($AExtPlugins){
  	if(is_array($AExtPlugins) == false)
  		$AExtPlugins = array();

  	return array_merge($AExtPlugins,
      array("devformatter" => DEVFMT_URL."devfmt_edit_plugin.js")
    );
  }

  function devfmt_addHTMLButton(){
    GLOBAL $DevFmt_SuppLangs;

    $Langs = Array();
    foreach($DevFmt_SuppLangs as $Lang)
      $Langs[] = "{n:'".$Lang['langname']."',s:'".array_shift(explode(".", $Lang['langfile']))."',f:".$Lang['fav']."}";

    echo "
  <script language=\"JavaScript\">
  // <![CDATA[
    Langs = new Array(".implode(",", $Langs).");
    HtmlEditor = true;
    ButtonIndex = -1;
    SelectedLangIndex = -1;
    EditorSelection = '';

    document.write(\"<div id='devfmt_langselector'></div>\");
    DevFmt_WriteDefaults = function(){
      jQuery('#devfmt_langselector').html('');
      sHTML = \"<center>\";
      sHTML += \"<table id='devfmt_langselectorarea'><tbody><tr><td>\";
      sHTML += \"<table width='100%'><tbody><tr><td>\";
      sHTML += \"<div class='devfmt_lsleft'>\";

      sHTML += \"<h3>Your favorites Languages</h3><select name='devfmt_langfavselection' size='7' onchange='DevFmt_ShowLangInfo(this)'>\";
      HasFav = false;
      for(i = 0; i < Langs.length; i++)
        if(Langs[i].f){
          HasFav = true;
          sHTML += \"<option value='\" + Langs[i].s +\"'>\" + Langs[i].n +\"</option>\";
        }
      sHTML += \"</select>\";
      sHTML += \"</div></td><td><div class='devfmt_lsright'>\";
      sHTML += \"<h3>Select a Language</h3><select name='devfmt_langselection' size='7' onchange='DevFmt_ShowLangInfo(this)'>\";
      for(i = 0; i < Langs.length; i++)
        sHTML += \"<option value='\" + Langs[i].s +\"'>\" + Langs[i].n +\"</option>\";
      sHTML += \"</select>\";
      sHTML += \"</div>\";
      sHTML += \"</td></tr></tbody></table>\";

      sHTML += \"<table id='DevFmt_LangInfo'><tbody>\" +
        \"<tr><td width='120px'>Name:</td><td class='langname'>...</td></tr>\" +
        \"<tr><td>Identification:</td><td class='langident'>...</td></tr>\" +
        \"</tbody></table>\";
      sHTML += \"<table id='devfmt_langselectorarea'><tbody><tr>\";
      sHTML += \"<td style='width:120px;font-weight:bold' id='tab_devfmt_code'>Code</td>\";
      sHTML += \"<td style='width:120px' id='tab_devfmt_preview'>Preview</td>\";
      sHTML += \"</tr></tbody></table><table width='100%' id='devfmt_langselectorarea'><tbody><tr>\";
      sHTML += \"<div id='devfmt_codeeditor'>\";
      sHTML += \"<textarea id='devfmt_content'>\" + EditorSelection + \"</textarea>\";
      sHTML += \"</div>\";
      sHTML += \"<div id='devfmt_preview' style='display:none'>\";
      sHTML += \"<div id='devfmt_previewcode'></div>\";
      sHTML += \"</div></tr></tbody></table>\";
      sHTML += \"</td></tr></tbody></table>\";

      UseCaption = (EditorSelection == \"\")? \"Insert the code\" : \"Update to code format\";

      sHTML += \"<input type='checkbox' id='devfmt_forcelines'/> Display Line numbers? <em>(Note: This option will force lines count to be displayed )</em><br />\";
      sHTML += \"<hr><input type='button' class='button-secondary' value='\" + UseCaption + \"' onclick='DevFmt_SelectLang()'/>\";
      sHTML += \"</center>\";

      jQuery('#devfmt_langselector').html(sHTML);

      if(HasFav){
        jQuery('select[name=devfmt_langfavselection]').get(0).selectedIndex = 0;
        DevFmt_ShowLangInfo(jQuery('select[name=devfmt_langfavselection]').get(0));
      }

      jQuery('#tab_devfmt_code').click(function(){
        jQuery('#devfmt_preview').hide();
        jQuery('#devfmt_content').show();
        jQuery(this).css('font-weight','bold');
        jQuery('#tab_devfmt_preview').css('font-weight','normal');
      });

      jQuery('#tab_devfmt_preview').click(function(){
        if(SelectedLangIndex != -1){
          jQuery('#devfmt_content').hide();
          jQuery('#devfmt_preview').show();
          jQuery(this).css('font-weight','bold');
          jQuery('#tab_devfmt_code').css('font-weight','normal');
          jQuery.post('".DEVFMT_URL."devfmt_ajax.php',
            {'preview': jQuery('textarea#devfmt_content').get(0).value,
             'preview_lang': Langs[SelectedLangIndex].s,
             'preview_lines': ((jQuery('#devfmt_forcelines').get(0).checked)? 'true' : '')}, function(data){
              jQuery('#devfmt_preview div').html(data);
            });
        }else{
          alert('Select a language.');
        }
      });
    }

    DevFmt_ShowSelector = function(){
      DevFmt_WriteDefaults();
      tb_show('DevFormatter','?TB_inline=1&modal=false&inlineId=devfmt_langselector');

      jQuery('#TB_ajaxContent').css('width', '');
      jQuery('#TB_ajaxContent').css('height', '90%');
      jQuery('#TB_ajaxContent').css('overflow', 'scroll');
    }

    DevFmt_IndexOfLang = function(ALangIdent){
      for(i = 0; i < Langs.length; i++)
        if(Langs[i].s == ALangIdent)
          return i;
      return -1;
    }

    DevFmt_ShowLangInfo = function(ASelect){
      if(ASelect.name == 'devfmt_langfavselection'){
        jQuery('select[name=devfmt_langselection]').get(0).selectedIndex = -1;
      }else{
        jQuery('select[name=devfmt_langfavselection]').get(0).selectedIndex = -1;
      }
      SelectedLangIndex = DevFmt_IndexOfLang(ASelect.value);
      jQuery('#DevFmt_LangInfo .langname').html(Langs[SelectedLangIndex].n);
      jQuery('#DevFmt_LangInfo .langident').html(ASelect.value);
    }

    DevFmt_SelectLang = function(){
      if((jQuery('select[name=devfmt_langselection]').get(0).selectedIndex == -1) &&
        (jQuery('select[name=devfmt_langfavselection]').get(0).selectedIndex == -1)){
        alert('Please, select a language first.');
        return false;
      }
      tb_remove();
      Langs[SelectedLangIndex].f = true;

      DevFmt_ConfigExts = new Array();
      if(jQuery('#devfmt_forcelines').get(0).checked){
        DevFmt_ConfigExts[DevFmt_ConfigExts.length] = 'lines';
      }

      if(DevFmt_ConfigExts.length == 0){
        DevFmt_ConfigExt = '';
      }else{
        DevFmt_ConfigExt = '[' + DevFmt_ConfigExts.join('-') + ']';
      }

      DevFmt_ContentStart = '<code lang=\"' + Langs[SelectedLangIndex].s + DevFmt_ConfigExt + '\">';
      DevFmt_TheContent = '' + jQuery('textarea#devfmt_content').get(0).value;
      DevFmt_ContentEnd = '</code>';
      if(HtmlEditor){
        edInsertContent(edCanvas, DevFmt_ContentStart + DevFmt_TheContent + DevFmt_ContentEnd);
      }else{
        tinyMCE.execInstanceCommand('content', 'mceReplaceContent', false,
          switchEditors.wpautop(DevFmt_ContentStart + DevFmt_TheContent + DevFmt_ContentEnd));
      }

      DevFmt_WriteDefaults();

      sFavs = '';
      for(i = 0; i < Langs.length; i++)
        if(Langs[i].f){
          if(sFavs != '') sFavs += '-';
          sFavs += Langs[i].s;
        }
      jQuery.post('".DEVFMT_URL."devfmt_ajax.php', {'favs': sFavs});
    }

    function DevFmt_ShowSelectorMCE(){
      HtmlEditor = false;
      ButtonIndex = -1;
      EditorSelection = tinyMCE.activeEditor.selection.getContent({format : 'text'});
      DevFmt_ShowSelector();
    }

    function ed_selectedcode(){
    	if(document.selection){
    		edCanvas.focus();
    	  return document.selection.createRange();
    	}else if (edCanvas.selectionStart || edCanvas.selectionStart == '0') {
    		startPos = edCanvas.selectionStart;
        return edCanvas.value.substring(startPos, edCanvas.selectionEnd);
      }
    }

    function ed_codeInsert(myField, i){
      HtmlEditor = true;
      ButtonIndex = i;
      EditorSelection = ed_selectedcode();
      DevFmt_ShowSelector();
    }

    jQuery(function($){
      $('#content').bind('onchange', function(){
        alert('changed');
      });
      for(i = 0; i < edButtons.length; i++)
        if(edButtons[i].id == 'ed_code')
          edCodeId = i;
      $(\"input#ed_code\").get(0).onclick = function(){
        ed_codeInsert(edCanvas, edCodeId);
      };
    });
  // ]]>
  </script>
    ";
  }

  function devfmt_addExtendsToMCE($AArConfig){
    $AArConfig['extended_valid_elements'] = "*[*]";
    $AArConfig['entities'] = "160,nbsp,38,amp,34,quot,162,cent,8364,euro,163,pound,165,yen,169,copy,174,reg,8482,trade,8240,permil,60,lt,62,gt,8804,le,8805,ge,176,deg,8722,minus";
    return $AArConfig;
  }

  function devfmt_commonHeader(){
    GLOBAL $DevFmt_Config;
    echo "<script language=\"JavaScript\"><!--\n var DevFmtUrl='".DEVFMT_URL."'; var DevFmtCopyText='".$DevFmt_Config['copyclipboartext']."'; //-->\n</script>\n";
    echo "<script type='text/javascript' src='".DEVFMT_URL."devfmt_common.js'></script>\n";
  }

  function devfmt_adminHeader(){
  	echo "
    <script type='text/javascript' src='".DEVFMT_URL."devfmt_common.js'></script>
    <script type='text/javascript' src='".DEVFMT_URL."devfmt_editor.js'></script>";

    devfmt_commonHeader();

    echo "
    <style type='text/css'>
    #devfmt_langselector {
      font-size: 16px;
      display: none;
      z-index: 999;
    }
    #tab_devfmt_code, #tab_devfmt_preview {
      cursor: pointer;
    }
    #devfmt_content, #devfmt_previewcode {
      width: 100%;
      height: 200px;
      border: 1px solid #000;
      padding: 0;
      margin: 0;
      overflow: scroll;
    }
    #devfmt_preview div pre {
      padding: 0;
      margin: 0;
    }
    #devfmt_content, #DevFmt_LangInfo {
      width : 500px;
    }
    .devfmt_langselectorarea {
      width: 500px;
    }
    .devfmt_lsleft, .devfmt_lsright, .devfmt_lsleft select, .devfmt_lsright select {
      width: 250px;
    }
    .devcodeblock tr {
      background: transparent;
    }
    .devcodeblock, .devcodeblock tr, .devcodeblock tr td {
      left : 0;
      top : 0;
      border: 0;
      padding: 0;
      margin: 0;
    }
    </style>\n";
    devfmt_DevFmtCSS();
  }

  function devfmt_DevFmtCSS(){
    GLOBAL $DevFmt_Config;

    if(isSet($_POST) && ($_GET['page'] == "devformatter/devformatter.php"))
      if(IsSet($_POST['UpdateConfig']) && IsSet($_POST['devfmtcss']))
        $DevFmt_Config['devfmtcss'] = $_POST['devfmtcss'];

    if(trim($DevFmt_Config[devfmtcss]) != "")
      echo "<style type='text/css'>".$DevFmt_Config[devfmtcss]."</style>";
  }

  function devfmt_publicHeader(){
    GLOBAL $DevFmt_Config;
    devfmt_ReadConfigAndLangs();
    if($DevFmt_Config['linkjquery'])
      echo "<script type='text/javascript' src='".get_option('siteurl')."/wp-includes/js/jquery/jquery.js?ver=1.2.6'></script>\n";

    devfmt_commonHeader();

    echo "<script type='text/javascript' src='".DEVFMT_URL."devfmt_public.js'></script>\n";
    devfmt_DevFmtCSS();
  }

  function devfmt_initEditor($AEditor){
		if('tinymce' ==  wp_default_editor()){
      $AEditor .= "<script language='JavaScript'><!--\n jQuery('textarea#content').get(0).value = switchEditors.wpautop(jQuery('textarea#content').get(0).value); //-->\n</script>";
    }
    return $AEditor;
  }

  function devfmt_rollbackFormat($AContent){
    GLOBAL $post;
    return $post->post_content;
  }

  function devfmt_saveContent(&$AContent, $AFormatedArea){
    $FormatedAreas = array(uniqid(''), $AFormatedArea);
    while(preg_match("#".$AFormatedArea."#s", $AContent, $matches)){
      array_shift($matches);
      $FormatedAreas[] = $matches;
      $AContent = preg_replace("#".$AFormatedArea."#s", $FormatedAreas[0].(Count($FormatedAreas) - 2)." ", $AContent, 1);
    }
    return $FormatedAreas;
  }

  function devfmt_recoverContent(&$AContent, $AFormatedAreas){
    for($i = 2; $i < Count($AFormatedAreas); $i++){
      while(preg_match("#".$AFormatedAreas[0].($i - 1)." #", $AContent, $matches)){
        $formated = $AFormatedAreas[1];
        foreach($AFormatedAreas[$i] as $tmp)
          $formated = preg_replace("#\(.*?\)#", $tmp, $formated, 1);

        $AContent =  preg_replace("#".$AFormatedAreas[0].($i - 1)." #", $formated, $AContent, 1);
      }
    }
  }

  function devfmt_getLangTitle($ALang){
    GLOBAL $DevFmt_SuppLangs;
    foreach($DevFmt_SuppLangs as $Lang)
      if(strtolower($Lang['langfile']) == $ALang.".php")
        return $Lang['langname'];
    return "unknow";
  }

  function devfmt_GeSHiParseCode($ACode, $ALang, $ADevFmt = false){
    GLOBAL $DevFmt_Config;
    $geshi = new GeSHi(chr(2).$ACode.chr(2), $ALang, $DevFmt_Config['geshilangpath']);
    $geshi->overall_style = "";
    $geshi->overall_id = "";
    $geshi->overall_class = "";
    $geshi->code_style = "";
    $geshi->enable_keyword_links($DevFmt_Config['geshiuselink']);
    $geshi->enable_line_numbers(false);
    $geshi->set_header_type(GESHI_HEADER_PRE);
    $code = $geshi->parse_code();
    $code = substr($code, 5);
    $code = substr($code, 0, strlen($code) - 6);
    return str_replace(chr(2), "", $code);
  }

  function devfmt_ParseCode($ACode, $ALang, $ADevFmt){
    if($ACode == "") return $ACode;
    $code = $ACode;
    $code = str_replace("\r\n", "\n", $code);
    $code = str_replace("\n", "\r\n", $code);

    $OtherLang = true;
    // Handle PHP format [PHP, HTML ->]
    if((($ALang == "php") || ($ALang == "php-brief")) && (preg_match("#<\?(.*?)\?>#s", $code, $matches))){
      $OtherLang = false;
      $SvPhp = array(array(uniqid(''), "<\?(.*?)\?>"));

      while(preg_match("#<\?(.*?)\?>#s", $code, $match)){
        $check = $match[0];
        array_shift($match);
        $SvPhp[] = $match;
        $code = str_replace($check, $SvPhp[0][0].(Count($SvPhp) - 1)." ", $code);
      }

      $html = Array();
      for($i = 1; $i < Count($SvPhp); $i++){
        $html[] = Array($SvPhp[0][0].($i - 1)." ", $SvPhp[0][0].$i." ");
      }

      $code = devfmt_ParseCode($code, "html", $ADevFmt);

      for($i = 1; $i < Count($SvPhp); $i++){
        $SvPhp[$i][0] = devfmt_GeshiParseCode("<?" . $SvPhp[$i][0] . "?>", $ALang, $ADevFmt);

        $OpenTags = Array();
        if(preg_match("/\n(.*?)".$SvPhp[0][0].$i." /", $code, $match)){
          $tmp = $match[1];
          while(preg_match("/(<(\w+)([^>]*)>(.*?)<\/)/", $tmp, $match))
            $tmp = preg_replace("/(<(".$match[2].")([^>]*)>([^<]*)<\/".$match[2].">)/", ".", $tmp, 1);
          preg_match_all("/(<(\w+)([^>]*)>)/", $tmp, $matches);
          $OpenTags = $matches[0];
        }

        if(Count($OpenTags) > 0){
          $SvPhp[$i][0] = str_repeat("</span>", Count($OpenTags)).
            $SvPhp[$i][0].implode("", $OpenTags);
        }

        $code = preg_replace("#".$SvPhp[0][0].$i." #", $SvPhp[$i][0], $code, 1);
      }
    }

    // Handle HTML format [HTML, JavaScript, Style]
    if($ALang == "html"){
      $OtherLang = false;
      $SvScript = Array();
      while(preg_match("#<script(.*?)>(.*?)</script>#s", $code, $matches)){
        $id = $unid."script".Count($SvScript);
        if($matches[2] != ""){
          $subcode = devfmt_GeshiParseCode($matches[2], "javascript", $ADevFmt);
        }else
          $subcode = "";

        $SvScript[] = Array($id, $matches[1], $subcode);
        $code = str_replace($matches[0], $id, $code);
      }

      $SvStyle = Array();
      while(preg_match("#<style(.*?)>(.*?)</style>#s", $code, $matches)){
        $id = $unid."style".Count($SvStyle);
        if($matches[2] != ""){
          $subcode = devfmt_GeshiParseCode($matches[2], "css", $ADevFmt);
        }else
          $subcode = "";

        $SvStyle[] = Array($id, $matches[1], $subcode);
        $code = str_replace($matches[0], $id, $code);
      }

      foreach($SvScript as $script)
        $code = str_replace($script[0], "<script".$script[1].">".$script[0]."</script>", $code);

      foreach($SvStyle as $style)
        $code = str_replace($style[0], "<style".$style[1].">".$style[0]."</style>", $code);

      $code = devfmt_GeshiParseCode($code, $ALang, $ADevFmt);

      foreach($SvScript as $script)
        $code = str_replace($script[0], $script[2], $code);

      foreach($SvStyle as $style)
        $code = str_replace($style[0], $style[2], $code);
    }

    // Handle others formats
    if($OtherLang)
      $code = devfmt_GeshiParseCode($code, $ALang, $ADevFmt);

    return $code;
  }

  function devfmt_ParseStructure($ACode, $ALang, $AOptions, $AStyle = ""){
    if($AStyle != "") $AStyle = " style=\"".$AStyle."\"";
    return '<pre class="codeblock" title="'.devfmt_getLangTitle($ALang).'"'.$AStyle.'>'.
      '<input type="hidden" value="'.implode("-", $AOptions).'">'.
      '<pre class="code">'.$ACode.'</pre></pre>';
  }

  function devfmt_ContentCheckCode($AContent, $ADevFmt = false){
    GLOBAL $DevFmt_Config;

    $GeshiOperator = "!<code(.*?)>(.*?)</code>!is";

    $codes = array();
    $unid = uniqid('');
    $i = 0;
    while(preg_match($GeshiOperator, $AContent, $matches)){
      $i++;
      $codes[$i]['options'] = $matches[1];
      if($brformat)
        if(trim($matches[2]) != ""){
          $codelines = explode("\r\n", $matches[2]);
          if(trim($codelines[0]) == "")
            array_shift($codelines);

          $matches[2] = implode("\r\n", $codelines);
        }

      $codes[$i]['code'] = $matches[2];
      $AContent = str_replace($matches[0], $unid.$i." ", $AContent);
    }

    $i = 0;
    while(preg_match("!".$unid."([0-9]+) !is", $AContent, $matches)){
      $i++;
      $opts = array();
      if(trim($codes[$i]['options']) != ""){
        $optsdata = explode(" ", $codes[$i]['options']);
        foreach($optsdata as $option){
          $opt = explode("=", $option);
          $opt[1] = trim($opt[1]);
          if($opt[1][0] == "\"")
            $opt[1] = substr($opt[1], 1, strlen($opt[1]) - 2);
          $opts[strtolower($opt[0])] = $opt[1];
        }
      }

      if(IsSet($opts['lang'])){
        $opts['lang'] = StrToLower($opts['lang']);
        if(strpos($opts['lang'], '[') !== false){
          if(preg_match("/\[(.*?)\]/", $opts['lang'], $match)){
            $tmpOpts = explode("-", $match[1]);
            $opts['options'] = Array();
            if(is_array($tmpOpts))
              foreach($tmpOpts as $Opt)
                $opts['options'][$Opt] = $Opt;

            $opts['lang'] = str_replace($match[0], '', $opts['lang']);
          }
        }
        if(!IsSet($opts['options'])){
          $opts['options'] = Array();
        }

        if($DevFmt_Config['displaylinenumbers'])
          $opts['options']['lines'] = "lines";

        if(!IsSet($opts['style'])){
          $opts['style'] = "";
        }

        $code = devfmt_ParseStructure(
          devfmt_ParseCode($codes[$i]['code'], $opts['lang'], $ADevFmt),
          $opts['lang'], $opts['options'], $opts['style']);
      }else{
        $code = "<pre>".$codes[$i]['code']."</pre>";
      }
      $AContent = preg_replace("!".$unid."([0-9]+) !is", $code, $AContent, 1);
    }
    return $AContent;
  }

  $DefaultFilters = Array();

  function devfmt_ContentFormat($AContent, $AFilter){
    GLOBAL $DefaultFilters, $DevFmt_Config, $DevFmt_SuppLangs, $DevFmt_FiltersToAvoid, $post;

    $AContent = devfmt_ContentCheckCode($AContent, true);

    if(($AFilter == 'example') || ($DevFmt_Config['usedevformat'])){
      if($AFilter == 'comment_text'){
        $AContent = preg_replace('!(<script.*?>)(.*?)</script>!is', '', $AContent);
        $AContent = preg_replace('!(<iframe.*?>)(.*?)</iframe>!is', '', $AContent);
        $AContent = preg_replace('!(<meta.*?)(.*?)>!is', '', $AContent);
      }

      $svScript = devfmt_saveContent($AContent, "<script(.*?)>(.*?)</script>");
      $svStyle = devfmt_saveContent($AContent, "<style(.*?)>(.*?)</style>");
      $svTextarea = devfmt_saveContent($AContent, "<textarea(.*?)>(.*?)</textarea>");
      $svSelect = devfmt_saveContent($AContent, "<select(.*?)>(.*?)</select>");
      $svPre = devfmt_saveContent($AContent, "<pre(.*?)>(.*?)</pre>");

      $AContent = str_replace("\r\n", "\n", $AContent);
      $AContent = str_replace("\n", "\r\n", $AContent);
      $AContent = preg_replace('!(<(pre|blockquote)(.*?)>)([ |\r\n])!', '$1', $AContent);

      $AContent = preg_replace('!(</(p|div|pre|ul|ol|li|dl|dd|dt|table|tr|th|td|h[1-6])>)([ |\r\n])!', '$1', $AContent);
      $AContent = preg_replace('!([ |\r\n])(<(p|div|pre|ul|ol|li|dl|dd|dt|table|tr|th|td)(.*?)>)!', '$2', $AContent);

      $AContent = preg_replace("/\r\n\r\n/", "{{2br}}", $AContent);
      $AContent = preg_replace("/\r\n/", '<br />', $AContent);

      if($DevFmt_Config['highlighttags'] && IsSet($post)){
        $posttags = get_the_tags($post->ID);
        if($posttags){
          $Tags = array();
          foreach($posttags as $tag) $Tags[] = $tag->name;
          arsort($Tags);
          $svAnyTag = devfmt_saveContent($AContent, "<(.*?)>");
          foreach($Tags as $tag)
            $AContent = preg_replace("/([ |\r|>|.|,|\/|:])(".$tag.")([ |\r|<|.|,|\/|:])/is",
              "$1<strong>$2</strong>$3", $AContent);
          devfmt_recoverContent($AContent, $svAnyTag);
          unset($svAnyTag);
        }
      }

      if($AFilter != "example"){
        foreach($DefaultFilters[$AFilter] as $key => $FilterGroup)
          foreach($FilterGroup as $FilterName => $FilterData)
            if(!array_search($FilterName, $DevFmt_FiltersToAvoid))
              $AContent = $FilterData['function']($AContent);
      }

      devfmt_recoverContent($AContent, $svScript);
      unset($svScript);
      devfmt_recoverContent($AContent, $svStyle);
      unset($svStyle);
      devfmt_recoverContent($AContent, $svTextarea);
      unset($svTextarea);
      devfmt_recoverContent($AContent, $svSelect);
      unset($svSelect);
      devfmt_recoverContent($AContent, $svPre);
      unset($svPre);

      $AContent = preg_replace("!({{2br}})!", "<br /><br />", $AContent);

      // Change pre class "code" to "devcode"
      $AContent = preg_replace('/(<pre class=[\'|\"]codeblock[\'|\"](.*?)>)/is', '<pre class="devcodeblock"$2>', $AContent);
      $AContent = preg_replace('/(<span class=[\'|\"]codelines[\'|\"](.*?)>)/is', '<span class="devcodelines"$2>', $AContent);
      $AContent = preg_replace('/(<pre class=[\'|\"]code[\'|\"](.*?)>)/is', '<pre class="devcode"$2>', $AContent);

    }else{
      foreach($DefaultFilters[$AFilter] as $key => $FilterGroup)
        foreach($FilterGroup as $FilterName => $FilterData)
          $AContent = $FilterData['function']($AContent);
    }
    return $AContent;
  }

  function devfmt_Formatter_the_content($AContent){
    return devfmt_ContentFormat($AContent, 'the_content');
  }

  function devfmt_Formatter_comment_text($AContent){
    return devfmt_ContentFormat($AContent, 'comment_text');
  }

  function devfmt_Formatter_the_excerpt($AContent){
    return devfmt_ContentFormat($AContent, 'the_excerpt');
  }

  function devfmt_createTables() {
  	global $DevFmt_Config, $DevFmt_SuppLangs, $table_prefix, $wpdb;

    $table_name = "{$table_prefix}devfmt_config";
    if($wpdb->get_var("show tables like '$table_name'") != $table_name) {

      $sqlDevFmtConfig = "CREATE TABLE `{$table_prefix}devfmt_config` (
        `geshilangpath` varchar(255) CHARACTER SET utf8 NOT NULL,
        `geshiuselink` tinyint(1) NOT NULL DEFAULT '0',
        `displaylinenumbers` tinyint(1) NOT NULL DEFAULT '0',
        `usedevformat` tinyint(1) NOT NULL DEFAULT '0',
        `devfmtcss` text CHARACTER SET utf8,
        `linkjquery` tinyint(1) DEFAULT '1',
        `highlighttags` tinyint(1) DEFAULT '0',
        `copyclipboartext` varchar(100) CHARACTER SET utf8 DEFAULT NULL
      );";

      $sqlSupportedLangs = "CREATE TABLE `{$table_prefix}devfmt_supplangs` (
        `langname` varchar(100) CHARACTER SET utf8 NOT NULL,
        `langfile` varchar(100) CHARACTER SET utf8 NOT NULL,
        `fav` tinyint(1) DEFAULT '0',
        PRIMARY KEY (`langname`,`langfile`)
      );";

      require_once(ABSPATH . 'wp-admin/includes/upgrade.php');
      dbDelta($sqlDevFmtConfig);
      dbDelta($sqlSupportedLangs);

      $DevFmt_Config['devfmtcss'] = "  .devcode, .devcodelines, .devcodeblock, .devcodetools {
    padding: 0;
    margin: 0;
    font-size: 12px;
    font-family: courier new;
  }
  .devcode {
    padding: 0px 5px;
  }
  .devcodeblock {
    margin: 1px;
    border: 1px solid #ccc;
    overflow: auto;
  }
  .devcodelines {
    padding-left: 5px;
    padding-right: 5px;
    background: #888;
    color: #fff;
  }
  .devcodetools {
    background: #888;
    color: #fff;
    text-align: right;
  }
  .devcodetools span {
    cursor: pointer;
  }";
      $DevFmt_Config['copyclipboartext'] = 'copy code';
      $DevFmt_Config['geshilangpath'] = DEVFMT_GESHIPATH;
      if(DIRECTORY_SEPARATOR == '\\'){ // win server
        $DevFmt_Config['geshilangpath'] = str_replace('|', '\\\\',
          str_replace('\\', '|', $DevFmt_Config['geshilangpath']));
      }
      devfmt_UpdateConfig();
      devfmt_UpdateSupportedLangs();
    }
  }

  register_activation_hook(__FILE__, 'devfmt_createTables');
  add_filter('tiny_mce_before_init', 'devfmt_addExtendsToMCE');
  add_action('init', 'devfmt_addInterface');
  add_action('admin_head', 'devfmt_adminHeader');
  add_action('admin_menu', 'devfmt_addPages');
  add_action('the_editor', 'devfmt_initEditor');
  add_action('richedit_pre', 'devfmt_rollbackFormat');

  function devfmt_HookFilter($AFilterName){
    GLOBAL $DefaultFilters, $wp_filter;
    $DefaultFilters[$AFilterName] = $wp_filter[$AFilterName];
    $wp_filter[$AFilterName] = Array();
    add_filter($AFilterName, 'devfmt_Formatter_'.$AFilterName);
  }

  devfmt_HookFilter('the_content');
  devfmt_HookFilter('comment_text');
  devfmt_HookFilter('the_excerpt');

  add_action('wp_head', 'devfmt_publicHeader');

  echo (IsSet($DevFmt_Config['usedevformat']))? "devfmt" : "";
?>